package com.nisum.BookInfo.service;

import com.nisum.BookInfo.dao.BookDao;
import com.nisum.BookInfo.dto.BookDto;
import com.nisum.BookInfo.entity.Book;
import com.nisum.BookInfo.mapper.BookMapper;


import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.r2dbc.core.DatabaseClient;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;
@Service
public class BookServiceImpl implements BookService{
   // @Autowired
   // private BookRepo bookRepo;
    @Autowired
    private BookDao bookDao;
  /* @Autowired
    private ModelMapper modelMapper;*/


   //saveBook
    public Mono<Book> saveBook(BookDto bookDto) {

       // Book book=  modelMapper.map(bookDto,Book.class); //mapper for BookDto to book
      Book book=  BookMapper.toEntity(bookDto);
        return   bookDao.saveBook(book);

    }

    // Get all books
    public Flux<Book> getAllBooks() {
        return bookDao.getAllBooks();
    }

    // Get a book by ID
    public Mono<Book> getBookById(Integer id) {
        return bookDao.getBookById(id);
    }


    // Update a book
    public Mono<Book> updateBook(Integer bookId, BookDto bookDto) {
       // Book book=  modelMapper.map(bookDto,Book.class); //mapper for BookDto to book
        Book book=  BookMapper.toEntity(bookDto);
        return   bookDao.updateBook(bookId,book);


    }

    public Mono<Void> deleteBook(Integer id) {
        return bookDao.deleteBook(id);
    }
}
